find_package(Git)

set(CTEST_BUILD_NAME)
set(GET_GIT_REF FALSE)
if(GIT_FOUND)
    execute_process(COMMAND ${GIT_EXECUTABLE} rev-parse --show-prefix
        WORKING_DIRECTORY ${CTEST_SOURCE_DIRECTORY} RESULT_VARIABLE GIT_PREFIX
        OUTPUT_VARIABLE URANIE_PREFIX OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(GIT_PREFIX EQUAL "0")
        if(NOT URANIE_PREFIX)
            set(GET_GIT_REF TRUE)
        endif()
    endif()
    if(GET_GIT_REF)
        execute_process(COMMAND ${GIT_EXECUTABLE} rev-parse --abbrev-ref HEAD
            WORKING_DIRECTORY ${CTEST_SOURCE_DIRECTORY} RESULT_VARIABLE GIT_REF
            OUTPUT_VARIABLE URANIE_BRANCH OUTPUT_STRIP_TRAILING_WHITESPACE)
        if(GIT_REF EQUAL "0")
            set(CTEST_BUILD_NAME ${URANIE_BRANCH})
        endif()
    endif()
endif()

if(NOT CTEST_BUILD_NAME)
    find_program(ROOT_EXECUTABLE root REQUIRED)
    execute_process(COMMAND ${ROOT_EXECUTABLE} -l -q ${CTEST_SOURCE_DIRECTORY}/dataSERVER/souRCE/UVersion.h
        "${CTEST_SOURCE_DIRECTORY}/tools/print_version.C(\"uranie_version\")"
        RESULT_VARIABLE ROOT_RESULT ERROR_VARIABLE ROOT_ERROR)
    if(NOT ROOT_RESULT EQUAL "0")
        message(FATAL_ERROR "${ROOT_EXECUTABLE}: UVersion.h failed")
    endif()
    if(ROOT_ERROR)
        message(WARNING "${ROOT_ERROR}")
    endif()
    file(READ uranie_version URANIE_VERSION)
    string(STRIP ${URANIE_VERSION} URANIE_VERSION)
    set(CTEST_BUILD_NAME ${URANIE_VERSION})
endif()

if(DEFINED ENV{BUILD_NAME_SUFFIX})
    set(CTEST_BUILD_NAME ${CTEST_BUILD_NAME}_$ENV{BUILD_NAME_SUFFIX})
endif()
