if(UNIX)
    set(CTEST_CMAKE_GENERATOR "Unix Makefiles")
elseif(WIN32)
    set(CTEST_CMAKE_GENERATOR "Visual Studio 17 2022")
endif()

cmake_host_system_information(RESULT CTEST_SITE QUERY HOSTNAME)
find_program(LSB_RELEASE_EXEC lsb_release)
find_program(POWERSHELL_EXEC powershell)
if (LSB_RELEASE_EXEC)
    execute_process(COMMAND ${LSB_RELEASE_EXEC} -is
        OUTPUT_VARIABLE DISTRIBUTION_NAME
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    execute_process(COMMAND ${LSB_RELEASE_EXEC} -rs
        OUTPUT_VARIABLE DISTRIBUTION_VERSION
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    set(CTEST_SITE "${CTEST_SITE} (${DISTRIBUTION_NAME} ${DISTRIBUTION_VERSION})")
elseif(POWERSHELL_EXEC)
    execute_process(COMMAND ${POWERSHELL_EXEC} -Command
        "(Get-ComputerInfo).WindowsProductName"
        OUTPUT_VARIABLE WINDOWS_VERSION
        OUTPUT_STRIP_TRAILING_WHITESPACE)
    set(CTEST_SITE "${CTEST_SITE} (${WINDOWS_VERSION})")
else()
    set(CTEST_SITE "${CTEST_SITE} (${CMAKE_SYSTEM_NAME})")
endif()

include(ProcessorCount)
ProcessorCount(NUM_PROCS_AVAILABLE)
math(EXPR NUM_PROCS_USED "${NUM_PROCS_AVAILABLE}/2 + 1")
message(STATUS "Number of processors used / available: ${NUM_PROCS_USED} / ${NUM_PROCS_AVAILABLE}")
