#-------------------------------------------------------------------------
# JSONCPP installation through archive
#-------------------------------------------------------------------------

# The jsoncpp path dir
set(JSONCPP_DIR "jsoncpp-1.9.5")
FILE(TO_NATIVE_PATH "${CMAKE_BINARY_DIR}/JSONCPP/SOURCE" JSONCPP_SOURCE_DIR)
FILE(TO_NATIVE_PATH "${CMAKE_BINARY_DIR}/JSONCPP/BUILD" JSONCPP_BUILD_DIR)
FILE(TO_NATIVE_PATH "${CMAKE_INSTALL_PREFIX}/JSONCPP/${JSONCPP_DIR}" JSONCPP_INSTALL_DIR)

FILE(TO_NATIVE_PATH "${JSONCPP_INSTALL_DIR}/lib" JSONCPP_LIB_DIR)
FILE(TO_NATIVE_PATH "${JSONCPP_INSTALL_DIR}/bin" JSONCPP_BIN_DIR)

if(UNIX)
    if(WITH-JSONCPP STREQUAL "ON")
        message(STATUS "Untar JSONCPP archive")
        exec_program(${CMAKE_COMMAND} ARGS -E  make_directory ${JSONCPP_SOURCE_DIR} OUTPUT_VARIABLE BLA)
        exec_program(${CMAKE_COMMAND} ARGS -E  make_directory ${JSONCPP_BUILD_DIR} OUTPUT_VARIABLE BLA)
        exec_program(${CMAKE_COMMAND} ARGS -E  make_directory ${JSONCPP_INSTALL_DIR} OUTPUT_VARIABLE BLA)
        exec_program(${CMAKE_COMMAND} ARGS -E chdir ${CMAKE_SOURCE_DIR}/tools tar zxf "${CMAKE_SOURCE_DIR}/tools/${JSONCPP_DIR}.tar.gz" -C ${JSONCPP_SOURCE_DIR})

        message(STATUS "** Configuring JSONCPP...")
        exec_program(${CMAKE_COMMAND} ARGS -E chdir "${JSONCPP_BUILD_DIR}" cmake
            -DBUILD_SHARED_LIBS=ON -DBUILD_STATIC_LIBS=OFF -DCMAKE_INSTALL_PREFIX=${JSONCPP_INSTALL_DIR}
            "${JSONCPP_SOURCE_DIR}/${JSONCPP_DIR}")
        message(STATUS "**  Done")
        message(STATUS "** Compiling and installing JSONCPP")
        exec_program(${CMAKE_COMMAND} ARGS -E chdir "${JSONCPP_BUILD_DIR}" cmake --build . --config Release --target install)
        message(STATUS "**  Done")

        list(APPEND CMAKE_INCLUDE_PATH ${JSONCPP_INSTALL_DIR}/include)
        list(APPEND CMAKE_LIBRARY_PATH ${JSONCPP_LIB_DIR})
    endif()
endif()
