set(CTEST_SOURCE_DIRECTORY  "${CTEST_SCRIPT_DIRECTORY}")
set(CTEST_BINARY_DIRECTORY  ".")

include("${CTEST_SCRIPT_DIRECTORY}/CTest/machines.cmake")
include("${CTEST_SCRIPT_DIRECTORY}/CTest/build.cmake")
include("${CTEST_SCRIPT_DIRECTORY}/CTestCustom.cmake")

# Liste des fichiers à exlure du taux de couverture
set(CTEST_CUSTOM_COVERAGE_EXCLUDE
    ${CTEST_CUSTOM_COVERAGE_EXCLUDE}
    ".*Dict.cxx"
    "/modeler/souRCE/niSP/*"
    "/modeler/souRCE/aniSP/*"
    "/modeler/souRCE/PGauss/*"
    "/optimizer/souRCE/viZIR/*"
    "/reoptimizer/souRCE/viZIR/*"
    "/sampler/souRCE/akconst.*"
    "/sampler/souRCE/boselink.*"
    "/sampler/souRCE/construct.*"
    "/sampler/souRCE/galois.*"
    "/sampler/souRCE/gfields.*"
    "/sampler/souRCE/nisp_smo.*"
    "/sampler/souRCE/oa.*"
    "/sampler/souRCE/primes.*"
    "/sampler/souRCE/simplex.*"
)

set(CTEST_COVERAGE_COMMAND gcov)

set(ENV{CMAKE_BUILD_PARALLEL_LEVEL} ${NUM_PROCS_AVAILABLE})

ctest_start(Experimental)
ctest_configure(OPTIONS "-DCMAKE_BUILD_TYPE=Debug;-DWITH-COVERAGE=ON")
ctest_submit()

ctest_build(TARGET "install")
ctest_submit()

ctest_test()
ctest_coverage()
ctest_submit()
