set(CTEST_SOURCE_DIRECTORY  "${CTEST_SCRIPT_DIRECTORY}")
set(CTEST_BINARY_DIRECTORY  ".")

include("${CTEST_SCRIPT_DIRECTORY}/CTest/machines.cmake")
include("${CTEST_SCRIPT_DIRECTORY}/CTest/build.cmake")
include("${CTEST_SCRIPT_DIRECTORY}/CTestCustom.cmake")

# Definitions pour Valgrind
find_program(CTEST_MEMORYCHECK_COMMAND NAMES valgrind)
exec_program("root-config --etcdir" OUTPUT_VARIABLE ROOT_ETCDIR)
set(CTEST_MEMORYCHECK_COMMAND_OPTIONS " --suppressions=${ROOT_ETCDIR}/valgrind-root.supp --suppressions=${CTEST_SCRIPT_DIRECTORY}/valgrind-uranie-root.supp --show-possibly-lost=no  --leak-check=full ")

set(ENV{CMAKE_BUILD_PARALLEL_LEVEL} ${NUM_PROCS_AVAILABLE})

ctest_start(Experimental)
ctest_configure(OPTIONS "-DCMAKE_BUILD_TYPE=Debug")
ctest_submit()

ctest_build(TARGET "install")
ctest_submit()

ctest_memcheck()
ctest_submit()
