/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2024 CEA/DEN
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   forkcode.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2024-10-02
 
 \brief  structure de gestion des processus de calculs
*/

#ifndef __FORKCODE__
#define __FORKCODE__

#ifdef WIN32
#define _WIN32_WINNT 0x0A00
#endif
#include <boost/process.hpp>

namespace URANIE
{
namespace Launcher
{

typedef struct unforkjob {
    boost::process::child *job;
    int pattern;
    TString workdir;
    TString command;
} forkcode;

}} //namespace

#endif
