//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2025 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.4 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TLibCodeEval.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2011-04-04.15.35.59

 \brief encapsulation dun TCode
 */

#ifndef __LIBCODEEVAL__
#define __LIBCODEEVAL__

#include <sstream>

//ROOT
#include "Rtypes.h"
#include "TString.h"
#include "TList.h"

// Uranie
#include "Relauncher.h"
#include "TCodeBase.h"

namespace URANIE
{
namespace Relauncher
{

class TLibCodeEval: public TCodeBase
{
public:
    TLibCodeEval();
    virtual ~TLibCodeEval(void);
    
    virtual TEval *rebuild(int rank, Bool_t chef = kTRUE);
    virtual Bool_t unbuild();
    
    virtual int callFunction();
    virtual TLibCodeEval *clone() = 0;
    virtual int runCode() = 0;
    
    ClassDef(URANIE::Relauncher::TLibCodeEval, ID_RELAUNCHER)
};


class TCJitCodeEval: public TCodeBase
{
protected:
    void (*_fun)();

public:
    TCJitCodeEval(void (*fun)());
    virtual ~TCJitCodeEval(void);
    
    virtual TEval *rebuild(int rank, Bool_t chef = kTRUE);
    virtual Bool_t unbuild();
    
    virtual int callFunction();
    
    ClassDef(URANIE::Relauncher::TCJitCodeEval, ID_RELAUNCHER)
};


}} //namespace

#endif

