//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2025 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.4 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TPyCodeEval.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2011-04-04.15.35.59

 \brief encapsulation dun TCode
 */

#ifndef __PYCODEEVAL__
#define __PYCODEEVAL__

#include <sstream>

//ROOT
#include "Rtypes.h"
#include "TString.h"
#include "TList.h"

// Uranie
#include "Relauncher.h"
#include "TCodeBase.h"

#include "Python.h"

namespace URANIE
{
namespace Relauncher
{

class TPyCodeEval: public TCodeBase
{
protected:
    PyObject *_fun;

public:
    TPyCodeEval(PyObject *fun);
    virtual ~TPyCodeEval(void);
    
    virtual TEval *rebuild(int rank, Bool_t chef = kTRUE);
    virtual Bool_t unbuild();
    //virtual void setTmpDir(int id);
    
    virtual int callFunction();
    
    ClassDef(URANIE::Relauncher::TPyCodeEval, ID_RELAUNCHER)
};


}} //namespace

#endif

